Index: main/pbx.c
===================================================================
--- main/pbx.c	(revision 89)
+++ main/pbx.c	(working copy)
@@ -7779,11 +7779,9 @@
 {
 	int res = 0;
 
-	ast_channel_lock(chan);
-
 	if (chan->pbx) { /* This channel is currently in the PBX */
 		ast_explicit_goto(chan, context, exten, priority + 1);
-		ast_softhangup_nolock(chan, AST_SOFTHANGUP_ASYNCGOTO);
+		ast_softhangup(chan, AST_SOFTHANGUP_ASYNCGOTO);
 	} else {
 		/* In order to do it when the channel doesn't really exist within
 		   the PBX, we have to make a new channel, masquerade, and start the PBX
@@ -7792,6 +7790,8 @@
 		if (!tmpchan) {
 			res = -1;
 		} else {
+			ast_channel_lock(chan);
+
 			if (chan->cdr) {
 				ast_cdr_discard(tmpchan->cdr);
 				tmpchan->cdr = ast_cdr_dup(chan->cdr);  /* share the love */
@@ -7824,9 +7824,9 @@
 					res = -1;
 				}
 			}
+			ast_channel_unlock(chan);
 		}
 	}
-	ast_channel_unlock(chan);
 	return res;
 }
 
